pampinus/pampinus/urls.py
from django.contrib import admin
from django.urls import path
from django.views.generic.base import RedirectView

from instances import views as instances_views
from dbbackups import views as dbbackups_views

urlpatterns = [
    path('', RedirectView.as_view(url='/dbbackups/')),
    path('admin/', admin.site.urls),
    path('instances/', instances_views.instance_list, name='instance_list'),
    path('instances/<str:pk>/', instances_views.instance_show, name='instance_show'),
    path('servers/', instances_views.server_list, name='server_list'),
    path('servers/<str:hostname>/', instances_views.server_show, name='server_show'),
    path('dbbackups/', dbbackups_views.backup_status, name='backup_status'),
    path('dbbackups/jobs/', dbbackups_views.backup_list, name='backup_list'),
    path('dbbackups/jobs/<int:pk>/', dbbackups_views.backup_show, name='backup_show'),
    path('dbbackups/<str:dc>/<str:section>/<str:backup_type>/',
         dbbackups_views.backup_status_section, name='backup_status_section'),

]

pampinus/instances/models.py
from django.db import models

wmf_datacenters = [
    ('eqiad', 'eqiad (db1XXX)'),
    ('codfw', 'codfw (db2XXX)'),
    ('esams', 'esams (db3XXX)'),
    ('ulsfo', 'ulsfo (db4XXX)'),
    ('eqsin', 'eqsin (db5XXX)'),
    ('drmrs', 'drmrs (db6XXX)')
]


class Rack(models.Model):
    "Racks (have specific id on netbox"

    class Meta:
        unique_together = (('name', 'dc'),)
        db_table = 'racks'

    name = models.CharField(max_length=5,
                            help_text="Rack name.")
    identifier = models.IntegerField(primary_key=True,
                                     help_text="Rack identifier on Netbox")
    dc = models.CharField(max_length=100,
                          choices=wmf_datacenters,
                          help_text="Datacenter where the rack is physically located")

    def __str__(self):
        return f'{self.name} ({self.dc})'


class Server(models.Model):
    """Physical or virtual server."""

    DCS = wmf_datacenters
    os_versions = {
        'jessie': '8',
        'stretch': '9',
        'buster': '10',
        'bullseye': '11',
        'bookworm': '12',
        'trixie': '13',
    }

    class Meta:
        db_table = 'servers'

    fqdn = models.CharField(max_length=300,
                            primary_key=True,
                            help_text="Fully qualified domain name a physical or "
                                      "virtual linux server.")
    hostname = models.CharField(max_length=100,
                                db_index=True,
                                help_text="Hostname of the server.")
    rack = models.ForeignKey(Rack,
                             on_delete=models.SET_NULL,
                             null=True,
                             blank=True,
                             help_text="Netbox identifier where the server "
                                       "is physically located within the "
                                       "datacenter.")

    ip = models.GenericIPAddressField(null=True,
                                      blank=True,
                                      help_text="IP address (v4 or v6) of the server")
    os_version = models.CharField(max_length=100,
                                  null=True,
                                  blank=True,
                                  help_text="String representing the operating "
                                            "system version of the server (e.g. 11.5)")
    last_boot = models.DateTimeField(null=True,
                                     blank=True,
                                     help_text="Timestamp of when the server "
                                               "last booted up, to track "
                                               "its uptime.")

    def __str__(self):
        return self.fqdn


class Instance(models.Model):
    """MySQL server instance."""
    INSTANCE_GROUPS = [
        ('core', 'MediaWiki Core Server that will serve production traffic'),
        ('misc', 'Miscelaneous DB (Phab, bacula, etherpad, zarcillo)'),
        ('dbstore', 'Backup source or analytics servers (dbstore)'),
        ('parsercache', 'MediaWiki Parser Cache'),
        ('cloud', 'CloudDB (formerly, labsdb)'),
        ('test', 'Test Server')]

    class Meta:
        db_table = 'instances'

    name = models.CharField(max_length=300,
                            primary_key=True,
                            help_text="The name of the mysql instance.")
    server = models.ForeignKey(Server,
                               on_delete=models.CASCADE,
                               help_text="The name of the server where the "
                                         "instance lives.")
    port = models.IntegerField(help_text="The main port number where the "
                                         "instance listens to incoming "
                                         "connections.")
    instance_group = models.CharField(max_length=30,
                                      choices=INSTANCE_GROUPS,
                                      help_text=("Basic group the instance belongs to"))
    version = models.CharField(max_length=100,
                               null=True,
                               blank=True,
                               help_text="The version of the server running "
                                         "in that instance.")
    last_start = models.DateTimeField(null=True,
                                      blank=True,
                                      help_text="Timestamp of when the instance "
                                                "last started running, to track "
                                                "its uptime.")

    def __str__(self):
        return self.name


class Section(models.Model):
    """MySQL sections (replica sets)"""

    REPLICATION_GROUPS = [
        ('mw', 'MediaWiki'),
        ('test', 'Test'),
        ('analytics', 'Data Engineering'),
        ('misc', 'Miscelaneous'),
        ('cloud', 'WMF Cloud')]

    class Meta:
        db_table = 'sections'

    name = models.CharField(max_length=30,
                            primary_key=True,
                            help_text="Section identifier")
    replication_group = models.CharField(max_length=30,
                                         choices=REPLICATION_GROUPS)
    standalone = models.BooleanField(default=False)

    instances = models.ManyToManyField(Instance, db_table='section_instances')

    def __str__(self):
        return self.name


class Master(models.Model):
    """Replication primary instances on each dc"""

    class Meta:
        unique_together = (('section', 'dc'),)
        db_table = 'masters'

    dc = models.CharField(max_length=100,
                          choices=Server.DCS,
                          help_text="Datacenter in which the instance is "
                                    "a primary server.")
    instance = models.ForeignKey(Instance,
                                 on_delete=models.RESTRICT,
                                 help_text="Instance name that is the "
                                           "primary one on given DC.")
    section = models.ForeignKey(Section,
                                on_delete=models.CASCADE,
                                help_text="Reference to a section "
                                          "(replica set) name.")

    def __str__(self):
        return f'{self.section.name} ({self.dc})'

pampinus/templates/servers/list.html
{% extends 'base.html' %}
{% block content %}
{% load static %}
{% load os_version %}
  <div class="toggle">
  <a href="/instances">By instance</a><a class="inactive">by server</a>
  </div>
  <h2>List of database servers</h2>
  <table id="server-list">
  <thead>
  <tr>
    <th class="fqdn">fqdn</th>
    <th class="hostname">hostname</th>
    <th class="dc">dc</th>
    <th class="rack">rack</th>
    <th class="ip">ip</th>
    <th class="os-version">os</th>
    <th class="uptime">uptime</th>
    <th class="instances"># instances</th>
    <th class="external-links">external links</th>
    </tr></thead>
  <tbody>
  </tr>
    {% for server in servers %}
    <tr>
      <td><a class="visited_enabled" href="/servers/{{ server.hostname }}">{{ server.fqdn }}</a></td>
      <td>{{ server.hostname }}</td>
      <td><span class="label label-{{ server.rack.dc }}">{{ server.rack.dc }}</a></td>
      <td><a class="visited_enabled" href="https://netbox.wikimedia.org/dcim/racks/{{ server.rack.identifier }}/">{{ server.rack.name }}</a></td>
      <td>{{ server.ip | default_if_none:""}}</td>
      <td data-sort="{{ server.os_version | default:'' }}"><span class="label label-{{ server.os_version | os_alias | default_if_none:'' }}">{{ server.os_version | os_alias | default_if_none:"" }}</span></td>
      <td data-sort="{{ server.last_boot | date:'c' }}">{{ server.last_boot | timesince}}</td>
      <td><span class="label label-numinstances">{{ server.instance_set.count }}</span></td>
      <td><a class="visited_enabled" href="https://netbox.wikimedia.org/dcim/devices/?q={{ server.hostname }}"><img src="{% static 'netbox.png' %}" alt="netbox icon" style="width:24px; height: 24px; vertical-align:middle;"></a>&nbsp;
      <a href="https://grafana.wikimedia.org/d/000000377/host-overview?var-server={{ server.hostname }}&amp;var-datasource=thanos"><img src="{% static 'grafana.png' %}" alt="grafana graph link" style="width:24px; height: 24px; vertical-align: middle"></a>&nbsp;
      <a href="https://icinga.wikimedia.org/cgi-bin/icinga/status.cgi?search_string={{ server.hostname }}"><img src="{% static 'icinga.png' %}" alt="icinga status link" style="width:24px; height: 24px; vertical-align: middle"></a>
      </td>
    </tr>
    {% endfor %}
  </table>
  <p>{{ servers.count }} servers shown.</p>
  <script>
  new Tablesort(document.getElementById('server-list'));
  </script>

{% endblock %}

pampinus/templates/servers/show.html
{% extends 'base.html' %}

{% load static %}
{% load os_version %}

{% block content %}
  <div class="toggle">
  <a href="/instances">By instance</a><a href="/servers">by server</a>
  </div>

<h2>Server {{ server.fqdn }}</h2>
  <table>
    <tr>
      <td>Fully qualified domain name</td>
      <td>{{ server.fqdn }}</td>
    </tr>
    <tr>
      <td>Hostname</td>
      <td>{{ server.hostname }}</td>
    </tr>
    <tr>
      <td>Datacenter</td>
      <td><a class="visited_enabled" href="https://netbox.wikimedia.org/dcim/sites/{{ server.rack.dc }}"><span class="label label-{{ server.rack.dc }}">{{ server.rack.dc }}</span></a></td>
    </tr>
    <tr>
      <td>Rack</td>
      <td><a class="visited_enabled" href="https://netbox.wikimedia.org/dcim/racks/{{ server.rack.identifier }}/">{{ server.rack.name }}</a></td>
    </tr>
    <tr>
      <td>IP Address</td>
      <td><a class="visited_enabled" href="https://netbox.wikimedia.org/ipam/ip-addresses/?q={{ server.ip }}">{{ server.ip | default_if_none:"" }} <img src="{% static 'netbox.png' %}" alt="netbox icon" style="vertical-align:middle;"></a></td>
    </tr>
    <tr>
      <td>OS version</td>
      <td><span class="label label-{{ server.os_version | os_alias | default_if_none:'' }}">{{ server.os_version | os_alias | default_if_none:"" }}</span> {{ server.os_version | default_if_none:"" }}</td>
    </tr>
    <tr>
      <td>Server Uptime</td>
      <td>{{ server.last_boot | timesince }} (Last boot: {{server.last_boot}})</td>
    </tr>
    <tr>
      <td>Monitoring</td>
      <td>
      <a href="https://grafana.wikimedia.org/d/000000377/host-overview?var-server={{ server.hostname }}&amp;var-datasource=thanos"><img src="{% static 'grafana.png' %}" alt="grafana graph link"></a>
      <a href="https://icinga.wikimedia.org/cgi-bin/icinga/status.cgi?host={{ server.hostname }}"><img src="{% static 'icinga.png' %}" alt="icinga alerting link"></a>
      </td>
    </tr>
  </table>

  <h3>Instances in {{ server.fqdn }}</h3>
  <table id="instance-list">
    <thead>
      <tr>
      <th class="name">instance</th>
      <th class="port">port</th>
      <th class="instance_group">group</th>
      <th class="master">primary</th>
      <th class="sections">sections</th>
      <th class="version">version</th>
      <th class="uptime">uptime</th>
      </tr>
    </thead>
    <tbody>
        {% for instance in instances %}
        <tr>
        <td><a class="visited_enabled" href="/instances/{{ instance.name }}/">{{ instance.name }}</a></td>
        <td>{{ instance.port }}</td>
        <td><span class="label label-{{ instance.instance_group }}">{{ instance.instance_group }}</span></td>
        <td>{{ instance.master_set.all | join:", " | default:"replica" }}</td>
        <td>{{ instance.section_set.all | join:", " }}
        <td>{{ instance.version | default_if_none:""}}</td>
        <td>{{ instance.last_start| timesince | default_if_none:"" }}</td>
        </tr>
        {% endfor %}
    </tbody>
  </table>
  <p>{{ instances.count }} instances shown.</p>
  <script>
  new Tablesort(document.getElementById('instance-list'));
  </script>

{% endblock %}